use strict;
use warnings;
use Test::More;
use lib './t/lib';
use PScm::Test tests => 4;

BEGIN { use_ok('PScm') }

ok(
    !defined(eval {
            evaluate(<<EOF) }), 'let does not support recursion');
(let ((factorial
        (lambda (n)
          (if n (* n (factorial (- n 1)))
                1))))
  (factorial 4))
EOF

is($@, "no binding for factorial in PScm::Env\n",
    'let does not support recursion [2]');

eval_ok(<<EOF, "24", 'letrec and recursion');
(letrec ((factorial
           (lambda (n)
             (if n (* n (factorial (- n 1)))
                   1))))
  (factorial 4))
EOF

# vim: ft=perl
